﻿using System;
using System.IO;
using System.Reflection;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;

namespace ConsoleApp1
{
    class Program
    {
        static void Main(string[] args)
        {
            byte[] buffer = Encoding.UTF8.GetBytes("한글 테스트입니다.");

            int splitOffset = 8;

            byte[] buf1 = new byte[splitOffset];
            Array.Copy(buffer, buf1, splitOffset);

            byte[] buf2 = new byte[buffer.Length - splitOffset];
            Array.Copy(buffer, splitOffset, buf2, 0, buffer.Length - splitOffset);

            byte[] buf = null;
            {
                Decoder utf8Decoder = Encoding.UTF8.GetDecoder();
                SendBuffer(utf8Decoder, buf1);

                MemoryStream ms = new MemoryStream();
                BinaryFormatter formatter = new BinaryFormatter();
                formatter.Serialize(ms, utf8Decoder);

                buf = ms.ToArray();
            }

            {
                BinaryFormatter formatter = new BinaryFormatter();
                Decoder utf8Decoder = formatter.Deserialize(new MemoryStream(buf)) as Decoder;

                SendBuffer(utf8Decoder, buf2);
            }
        }
        
        private static void SendBuffer(Decoder utf8, byte[] buffer)
        {
            int len = utf8.GetCharCount(buffer, 0, buffer.Length);

            char[] textBuf = new char[len];
            utf8.GetChars(buffer, 0, buffer.Length, textBuf, 0);

            string txt = new string(textBuf);

            Console.WriteLine(txt);
        }
    }
}
